;
; man.asm - File manager lower half
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; starts in cfg_16
;

m_d018		= $02
m_p1		= $fb
m_p2		= $fd
m_p3		= $14
m_p4		= $22
m_p5		= $24
m_ascii		= $57
cconv		= $1e00
man_dirmem1	= $2000
man_dirmem2	= $6000
man_winstore	= $c000

DECORATION	= 1		;If 0 then old window decoration

		.if DECORATION=1
decor_bal	= 229;254
decor_jobb	= 231;252
                .else
decor_bal	= 243
decor_jobb	= 235
                .fi

manager		.proc
                .if SUPERCPU=1
                jsr scpu_no_opt		;no optimization, sprites!!!
                .fi

		lda #$37
		sta $1
                jsr newclall_t

		#sta_cfg_open

		ldx #manager_colors_end_exp-manager_colors_exp-1
ld              lda manager_colors,x
                sta manager_colors_exp,x
                dex			;set default colors
                bpl ld
                lda manager_dircolor_exp
                ora #128
                sta manager_dircolor_exp

		jsr manager_data_swap

		ldx #47
vlp		lda $d000-1,x
		sta man_oldvic-1,x
		dex
		bne vlp
                stx man_valid
                stx man_valid+1
		lda 650
		sta man_old650
                lda 657
                sta man_old657

		jsr man_check_sign
                beq redraw

		lda ActualDev
                cmp #31
                bcs *+6
                cmp #8
                bcs *+4
                lda #12
		sta man_drive
		sta man_drive+1
                ldx #5
ldk             lda defaultp-1,x
                sta man_relpath-1+$000,x
                sta man_relpath-1+$100,x
                dex
                bne ldk
		stx man_bar
		stx man_bar+1
		stx man_el_l
		stx man_el_l+1
		stx man_el_h
		stx man_el_h+1
                stx man_partition
                stx man_partition+1
		stx man_selectedwin	;0
                inx
                stx man_parlist
                stx man_parlist+1

		lda #<man_input
		ldy #>man_input
                jsr ident_drive.in
                lda man_floppy
                sta man_floppy+1

		jsr man_set_sign
                #jmps redraw
                
restart		jsr manager_data_swap
		.if SUPERCPU=1
                jsr scpu_no_opt		;no optimization, sprites!!!
                .fi

redraw		#sta_cfg_16
		jsr getcconv
		#sta_cfg_open
                ldx #4
                ldy #8
                lda #8+48*4
                sec
ldf		pha
		lda manager_bar_color_exp
		sta $d027,x
                lda #35
                sta $7f8,x
                pla
                sta $d000,y
                sbc #48
                dey
                dey
                dex
                bpl ldf
		lda #128
		sta 650
                sta 657
                sta m_d018
		asl
                sta $d015
		sta $d010
		sta 198
		sta msgmode
		sta $d017
		sta $d01c
		jsr bary
		ldx #63
l		sta $08c0,x
		cpx #24
                bne *+4
                lda #255
		dex
		bpl l
                lda #6
                sta man_savedwind
                lda #<man_winstore
                sta man_savedwin
                lda #>man_winstore
                sta man_savedwin+1

		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda manager_brcolor_exp
		sta $d020
		lda manager_bgcolor_exp
		sta $d021
		lda #200
		sta $d016
		lda #27
		sta $d011
		lda #22
		sta $d018
		lda #3
		sta $dd00
		lda #63
		sta $dd02
                lsr			;lda #%00011111
		sta $d01b
		sta $d01d
		jsr clrscr
		lda manager_misc_color_exp
		ldx #0
rp		sta $d800,x
		sta $d900,x
		sta $da00,x
		sta $db00,x
		inx
		bne rp

                jsr topunsel		;cfg16

		jsr winselcolupdate	;cfg16

		lda man_selectedwin
		pha
		#lda0
		sta man_selectedwin
		sta man_oldsc_h
		sta man_oldsc_h+1
		jsr redrwincap
		inc man_selectedwin
		jsr redrwincap

                .if SUPERCPU=1
                sei
                sta scpu_hwenable
                sta scpu_basic		;full optimization
                sta scpu_hwdisable
                cli
                .fi

iy		lda $dc01
		eor #$7f
		beq iy

		ldx #110
rpf		lda $dd00
		bmi okn
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		dex
		bne rpf
okn
		pla
                and #1
		sta man_selectedwin
                eor #1
                sta man_selectedwin+1
		jsr changepanelforce
		jsr main_reload2
		jsr scrollbar
                jsr changepanelforce
		jsr main_reload2
		jsr scrollbar
                jsr topdir

klp		lda #%00011111
		sta $d015
		jsr vbn
		#jmps klp

vbn		jsr placebar
		jsr scrollbar

kllp		lda 651
		lsr
		beq xf
		lda #2
		sta 651
xf
		lda 653
		lsr
		lsr
		bcs topmenu	;C= key
		lsr
		bcc u		;control
		jsr changepanel
		jsr changepanel2
		lda #4
u2		bit 653
		bne u2		;wait release

u		lda 198
		beq kllp
		lda 631
		dec 198
		ldx man_selectedwin
                
                cmp #"A"
                bcc nq
                cmp #"Z"+1
uu              bcc main_quick
nq	        cmp #"A"+128
		bcc nq2
                cmp #"Z"+128+1
		bcc uu
nq2
		ldy #256-3
dh		iny
		iny
		iny
		cpy #funce-func
		beq nn
		cmp func,y
		bne dh
                
                cpy #funce2-func
                bcc bd
                #stz_a $d015
bd
		lda func+2,y
		pha
		lda func+1,y
		pha
nn		rts

defaultp	.text "CD//",0

func		.byte 17		;down
		.word main_down-1
		.byte 145		;up
		.word main_up-1
		.byte 19		;home
		.word main_home-1
		.byte 137		;f2
		.word main_home-1
		.byte 133		;f1
		.word main_pgup-1
		.byte 157		;left
		.word main_pgup-1
		.byte 136		;f7
		.word main_pgdn-1
		.byte 29		;right
		.word main_pgdn-1
		.byte 140		;f8
		.word main_end-1
		.byte 147		;clr
		.word main_end-1
		.byte "*"		;*
		.word main_invselect-1
		.byte "+"		;+
		.word main_allselect-1
		.byte "-"		;-
		.word main_noneselect-1
		.byte 20		;del
		.word main_select-1
funce2
		.byte "1"		;1
		.word main_reload-1
		.byte "."		;.
		.word main_parentdir-1
		.byte "/"		;/
		.word main_rootdir-1
		.byte "3"		;3
		.word main_view-1
		.byte 95		;<-
		.word main_exit-1
		.byte 13		;return
		.word main_return-1
		.byte 141		;sh+return
		.word main_shreturn-1
		.byte "5"		;5
		.word main_copy-1
		.byte "7"		;7
		.word main_mkdir-1
		.byte "8"		;8
		.word main_delete-1
                .byte "9"		;9
                .word main_command-1
funce

fullbar		.byte "D"+128,"E"+128,"S"+128,"U"+128
freebar		.byte "E"+128,"E"+128,"R"+128,"F"+128
txtloading	.byte 13,13,2,2,"LOADING"," "+128,"DIR",0
txttoomany	.byte 13,13,29,29,"TOO"," "+128,"MANY"," "+128
		.byte "FILES","!"+128,0
		.pend
;---------------------------
; Main quick search
;
main_quick	.proc
		pha
lp		jsr calc_filepos_cursor
                pla
                pha
                ldy #3
                jsr man_get
                beq x

		ldy man_el_h,x
		lda man_el_l,x
		sec
		adc man_bar,x
		bcc *+3
		iny
		cmp man_files_l,x
		tya
		sbc man_files_h,x
		bcs x
		lda man_bar,x
		cmp #10
		beq o2
		inc man_bar,x
                gne lp
                
x		pla
		#jmps printdir

o2		inc man_el_l,x
		bne lp
		inc man_el_h,x
                gne lp

		.pend
;---------------------------
; Main cursor down
;
main_down	.proc
		ldy man_el_h,x
		lda man_el_l,x
		sec
		adc man_bar,x
		bcc *+3
		iny
		cmp man_files_l,x
		tya
		sbc man_files_h,x
		bcs x
		lda man_bar,x
		cmp #10
		beq o2
		inc man_bar,x
x		rts

o2		inc man_el_l,x
		bne y
		inc man_el_h,x
y		#jmps printdir
		.pend
;---------------------------
; Main cursor up
;
main_up		.proc
		lda man_bar,x
		beq o1
		dec man_bar,x
x		rts

o1		lda man_el_l,x
		bne py
		lda man_el_h,x
		beq x
		dec man_el_h,x
py		dec man_el_l,x
		#jmps printdir
		.pend

;---------------------------
; Main reload dir
;
main_reload2	.proc
		jsr ident_drive
                jsr same_dir
                bne main_reload
in              ldx man_selectedwin+1
                lda man_valid,x
                beq main_reload
                jsr man_copypanel
                #jmps main_reload.in

main_reload	.proc
		jsr mloaddir
		jsr sortdir
in		ldx man_selectedwin
		#lda0
		sta man_el_l,x
		sta man_el_h,x
		sta man_bar,x
                lda #1
                sta man_valid,x
		jsr printdlabel
		jsr man_printstat
		#jmps printdir
;---------------------------
; Main (de)select file
;
main_select	.proc
		jsr calc_filepos_cursor
		jsr man_toggle_sel
		jsr man_printstat
		jsr printdir
		ldx man_selectedwin
		#jmps main_down
		.pend

;---------------------------
; Main invert selection
;
main_invselect	.proc
		#lda0
		.byte SKIP2
main_allselect	.proc
		lda #128
		.byte SKIP2
main_noneselect	.proc
		lda #1
		sta m_ascii+3

		#stz_a m_ascii+1
		#stz_aa m_ascii+2

lp		ldy man_selectedwin
		#ldatax m_ascii+1
		cmp man_files_l,y
		lda m_ascii+2
		sbc man_files_h,y
		bcs ss
		lda m_ascii+2
                lsr
		txa
		jsr calc_filepos
                jsr man_dir
                bmi k			;directory?
k1		lda m_ascii+3
		beq k2
		jsr man_sel
		bpl k
k2		jsr man_toggle_sel
k		inc m_ascii+1
		bne lp
		inc m_ascii+2
		#jmps lp

ss		jsr man_printstat
		#jmps printdir
		.pend

;---------------------------
; Main go to parent dir
;
main_parentdir	.proc
		jsr man_cdpp
in		jsr showerror
		#jmps main_reload
		.pend

;---------------------------
; Main go to root dir
;
main_rootdir	.proc
		jsr man_cdroot
                ldx man_selectedwin
                lda #1
		sta man_parlist,x
		#jmps main_parentdir.in
		.pend

;---------------------------
; Main viewer
;
main_view	.proc
		lda man_files_l,x
		ora man_files_h,x
		beq err
                lda man_parlist,x
                lsr
                bne err

		jsr calc_filepos_cursor
                jsr man_dir
                bmi err

		jsr man_copyfname

		ldx #10
		stx ActualFNLength
dp		lda viewf-1,x
		sta cconv-1,x
		dex
		bne dp
in
		#sta_cfg_open
		lda setup_boot_drive_exp
		#sta_cfg_16
		sta ActualDev

		lda #<cconv
		sta ActualFilename
		lda #>cconv
		sta ActualFilename+1

		#lda0
		tax
		ldy #$10
		sta ActualSecAddr
		jsr newload_t

		lda $90
		eor #$40
		bne pr
		bcc ui
pr		jsr read_errchannel
		jsr showerror
		ldx man_selectedwin
		lda man_drive,x
		sta ActualDev
		#jmps getcconv

err		rts

ui		pla
		pla

		ldx man_selectedwin
		lda man_drive,x
		sta ActualDev
                #lda0
                sta man_valid
                sta man_valid+1

		jsr manager_data_swap
		#psr manager.restart
		#psr gotobank0back
		#psr exit2basic
		#psr $1003
                .if SUPERCPU=1
                jsr scpu_default_opt
                .fi
		ldx #<$201
		ldy #>$201
		lda $200
		jmp exit2basic

viewf		.text "1//:VIEWER"
		.pend

;---------------------------
; Main exit
;
main_exit	.proc
		jsr savewin
		.word $571
		.byte 20,6

		jsr drawwin
                .word $571
		.byte 20,6
		.word txtexit

		lda 198
		beq *-2

		jsr restorewin

		dec 198
		lda 631
		cmp #"Y"
		beq exit
		cmp #"1"
		beq exit 		;exit
                rts

exit		pla
		pla
		jsr restorescreen
                jsr manager_data_swap
                .if SUPERCPU=1
                jsr scpu_default_opt
                .fi
		pla
		pla
		#psr $e37b
		jmp exit2basic

txtexit		.byte 13,13,2,1,"QUIT"," "+128,"THIS"," "+128,"SOFT","?"+128,13,13
		.byte 2,7,"Y","/"+128,"N",0
		.pend

restorescreen	.proc
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		ldx #46
vlp2		lda man_oldvic,x
		sta $d000,x
		dex
		bpl vlp2
		lda man_old650
		sta 650
		lda man_old657
		sta 657
		jsr clrscr
		jmp $e544
		.pend

;---------------------------
; Main return
;
main_return	.proc
		#lda0
		.byte SKIP2
main_shreturn	.proc
		lda #1
		sta ActualSecAddr
		lda man_files_l,x
		ora man_files_h,x
		beq x
                lda man_parlist,x
                lsr
                beq tu
		sta man_parlist,x
                jsr calc_filepos_cursor
                #lda0
                tay
                jsr man_get
                sta man_input+2
                jsr changepart
                jsr man_cdroot
                #jmps uf

x		rts

tu	       	jsr calc_filepos_cursor
		jsr man_dir
                bpl nd
		jsr man_cd
uf		jsr showerror
		#jmps main_reload

nd		jsr man_ext
		cmp #"C"
		bne nd2
		cpx #"B"
		bne nd2
		cpy #"M"
		bne nd2
		jsr man_cd2
		#jmps uf

nd2		jsr man_plugin
		bcc nd3

		jsr man_copyfname

		ldx #12+3
		stx ActualFNLength
		ldx #12
dm		lda hack-1,x
		sta cconv-1,x
		dex
		bne dm
		geq main_view.in

hack		.text "1//","P"+128,"LUGINS/:"
hackv

nd3		lda ActualSecAddr
		bne y
		lda #1
		#sta_cfg_open
		sta load_autostart_exp	;autostart
		#sta_cfg_16
y		jsr man_copyfname
		pla
		pla
		jsr restorescreen
                jsr manager_data_swap
		lda #128
		sta msgmode
		asl
		sta $0a
                .if SUPERCPU=1
                jsr scpu_default_opt
                .fi
		pla
		pla
		#psr $e16f
		jmp exit2basic
		.pend

;---------------------------
; Main go home
;
main_home	.proc
		#lda0
		sta man_bar,x
		sta man_el_l,x
		sta man_el_h,x
		#jmps printdir
		.pend

;---------------------------
; Main PgUp
;
main_pgup	.proc
		lda man_bar,x
		bne dpy2
		lda man_el_l,x
		sec
		sbc #11
                bcs ndn
		dec man_el_h,x
		bmi main_home
ndn		sta man_el_l,x
		#jmps printdir

dpy2		#lda0
		sta man_bar,x
		rts
		.pend

;---------------------------
; Main PgDn
;
main_pgdn	.proc
		lda #10
		cmp man_bar,x
		bne dpy2
		lda man_el_l,x
		adc #21-1
		tay
		lda man_el_h,x
		adc #0
		pha
		tya
		cmp man_files_l,x
		pla
		sbc man_files_h,x
		bcs main_end
		lda man_el_l,x
		adc #11
                bcc main_pgup.ndn
		inc man_el_h,x
                gcs main_pgup.ndn

dpy2		ldy man_files_h,x
		bne u
		cmp man_files_l,x
		bcs main_end
u		sta man_bar,x
		rts
		.pend

;---------------------------
; Main end
;
main_end	.proc
		lda #10
		ldy man_files_h,x
		bne u
		cmp man_files_l,x
		bcc u
		lda man_files_l,x
		sbc #1
		bcs vf
		#lda0
vf		sta man_bar,x
		rts

u		sta man_bar,x
		lda man_files_l,x
		sec
		sbc #11
		sta man_el_l,x
		lda man_files_h,x
		sbc #0
		sta man_el_h,x
		#jmps printdir
		.pend

;---------------------------
; Identify drive
;
ident_drive	.proc
		lda #<$430
		ldy #>$430
		ldx man_selectedwin
		beq *+6
		lda #<$610
		ldy #>$610

in		sta m_p5
		sty m_p5+1

		lda #160
		ldy #8
i		sta (m_p5),y
		dey
		bpl i

		lda #1
		sta man_floppy,x

		lda #"U"
		sta man_input
		lda #"I"
		sta man_input+1
		#stz_a man_input+2

		jsr do_errchannel

		lda man_errchannel
		cmp #"7"
		bne n5

		ldx #2
		lda #","
n		inx
		beq n5
		cmp man_errchannel,x
		bne n
		lda #" "
nn		dex
		beq n5
		cmp man_errchannel,x
		bne nn
		ldy #0
n3		inx
		lda man_errchannel,x
		cmp #","
		beq n6
		and #63
		ora #128
		sta (m_p5),y
		iny
		cpy #9
		bne n3

n6		ldy #1
		lda (m_p5),y
		cmp #"5"+128
		bne n5
		dey
		lda #"1"+128
		cmp (m_p5),y
		bne n5
		ldy #3
		cmp (m_p5),y
		bne n7
		dey
		lda (m_p5),y
		cmp #"4"+128
		beq n4
		cmp #"7"+128
		beq n4
		cmp #"8"+128
		beq n4
                gne n5
n7		lda (m_p5),y
		cmp #"0"+128
		bne n5
		dey
		lda (m_p5),y
                cmp #"7"+128
                beq n4
n5		ldx man_selectedwin	;no 1541/1571/1581/1570
		lsr man_floppy,x
n4		rts
;---------------------------
; Do chdir
;
man_cd2		.proc
		lda #"/"
		ldx #"0"
		gne man_cd.in

man_cd		.proc
		lda #"C"
		ldx #"D"
in		ldy #0
		sta (m_p1),y
		iny
		txa
		sta (m_p1),y
		iny
		lda #":"
		sta (m_p1),y
                iny
                lda #"."
                cmp (m_p1),y
                bne mvm
                iny
                cmp (m_p1),y
                bne mvm
                iny
                lda (m_p1),y
                beq man_cdpp
mvm
		jsr man_setupfname

		inc ActualFNLength
		inc ActualFNLength
		inc ActualFNLength

		lda m_p1
                pha
		clc
                adc #3
                sta ActualFilename
                lda m_p1+1
                pha
                adc #0
                sta ActualFilename+1

                jsr rel_path_m_p1
                
                ldx #0
dmf             lda (ActualFilename,x)
                beq mfd
                sta (m_p1),y
                inc ActualFilename
                bne *+4
                inc ActualFilename+1
                iny
                bne dmf
mfd		lda #"/"
		sta (m_p1),y
                iny
                txa
                sta (m_p1),y

		jsr topdir

		pla
		sta ActualFilename+1
                pla
                sta ActualFilename
		#jmps read_errchannel.inn
		.pend
;---------------------------
; Go to root
;
man_cdroot	.proc
		jsr rel_path_m_p1
		ldy #3
		lda #"/"
		ldx #1
		gne man_cdpp.in

;---------------------------
; Go to parent
;
man_cdpp	.proc
		jsr rel_path_m_p1
                cpy #4
                bne kx
                lda #"0"
                sta man_input
                ldx man_selectedwin
                lda #3
                sta man_parlist,x
                rts

kx              dey
                lda #"/"
jcn             dey
		cpy #5
		bcc man_cdroot
                cmp (m_p1),y
                bne jcn

		ldx #3
		lda #95
		sta man_input+2
		lda #"D"
		sta man_input+1
		lda #"C"
in		sta man_input
		lda #"/"
		sta (m_p1),y
                iny
		#lda0
		sta man_input,x
                sta (m_p1),y
                
                jsr topdir

;---------------------------
; Execute command, and print result
;
do_errchannel	.proc
		lda #<man_input
		sta ActualFilename
		lda #>man_input
		sta ActualFilename+1

		ldx #0
iy		lda man_input,x
		beq ie
		inx
		bne iy

ie
		.byte SKIP2
;---------------------------
; Check error channel
;
read_errchannel	.proc
		ldx #0
		stx ActualFNLength

inn		lda #15
		sta ActualSecAddr
		sta ActualLogical

		jsr newopen_t
		lda Status
		beq okp
ee		ldy #18
dg		lda notp,y
		sta man_errchannel,y
		dey
		bpl dg
		gmi uy

okp		ldx #15
		jsr newchkout_t
		bcs ee
		ldx #15
		jsr newchkin_t
		bcs ee
		ldx #0
di		jsr newgetin_t
		sta man_errchannel,x
		inx
		bmi uy
		lda Status
		beq di
		cmp #$40
		bne ee
uy
		jsr newclrchn_t
		lda #15
		jmp newclose_t

notp		.text "DEVICE NOT PRESENT",13
		.pend

;---------------------------
; Show error channel C=0 on error
;
showerror	.proc
		lda man_errchannel
                and #$fe
		cmp #"0"		;0/1
		beq v			;no error

		jsr savewin
		.word $593
		.byte 33,5

		jsr drawwin
                .word $593
		.byte 33,5
		.word txtdev

		ldx #0
		ldy #0
u		lda man_errchannel,y
		cmp #13
		beq u2
		ora #128
		sta $60c,x
		iny
                inx
                cpy #64
                beq u2
		cpy #32
		bne u
                ldx #40
                gne u

u2
		lda 198
		beq *-2
		dec 198

		jsr restorewin
                clc

v		rts

txtdev		.byte 13,2,9,"DEVICE"," "+128,"ERROR",13,1,0
		.pend
;---------------------------
; Do partition change
;
changepart	.proc
                lda #"C"
                sta man_input
                lda #"P"+128
                sta man_input+1
                ldx #<man_input
                ldy #>man_input
                lda #3
                jsr $ffbd
		jsr read_errchannel.inn
                #jmps showerror
                .pend
;---------------------------
; Change panel
;
changepanelforce .proc
		sec
		.byte SKIP1
changepanel	.proc
		clc
		#ldatax man_selectedwin
                sta man_selectedwin+1
		eor #1
		sta man_selectedwin
		tay
		lda man_drive,y
		sta ActualDev
                lda man_floppy,y
                bne masdrive
                bcs force
                lda ActualDev
                eor man_drive,x
		bne masdrive

                lda man_partition,y
                eor man_partition,x
                beq np		;same partition, no partition select

force		php
                ldx man_partition,y
                stx man_input+2
                inx
                beq illegal
                jsr changepart
illegal         plp
                bcc masdrive	;different partition, no directory change!
                gcs forc

np		jsr same_dir
		beq masdrive	;in same dir on same partiton

forc		jsr rel_path_filename
                ldy #0
vm              lda (ActualFilename),y
                beq kf
                iny
                bne vm
kf		sty ActualFNLength

                jsr read_errchannel.inn
                jsr showerror
masdrive	rts

changepanel2    .proc
		lda $d011
		bpl *-3
		jsr winselcolupdate
                jsr topdir
;---------------------------
; Move fileselection
;
placebar	.proc
		ldx man_selectedwin
		lda man_bar,x
		cpx #0
		beq i
		adc #12-1
i
		asl
		asl
		asl
		adc #66

;---------------------------
; Set file selector sprite position
;
bary		.proc
		sta $d001
		sta $d003
		sta $d005
		sta $d007
		sta $d009
		rts
		.pend

;---------------------------
; Set color of panels
;
winselcolupdate	.proc
		#sta_cfg_open
		lda #<$d828
		sta m_p1
		lda #>$d828
		sta m_p1+1
		lda manager_inactwincolor_exp
		ldx man_selectedwin
		bne r1
		lda manager_actwincolor_exp
r1
		jsr draw
		#sta_cfg_open
		lda #<$da08
		sta m_p1
		lda #>$da08
		sta m_p1+1
		lda manager_inactwincolor_exp
		ldx man_selectedwin
		cpx #1
		bne draw
		lda manager_actwincolor_exp

draw		ldy #39
lp		sta (m_p1),y
		dey
		bpl lp

		ldy #68
		ldx #11
lp2		sta (m_p1),y
		pha
		tya
		clc
		adc #40
		tay
		pla
		bcc *+4
		inc m_p1+1
		dex
		bne lp2
		#sta_cfg_16
		rts
		.pend

;---------------------------
; Draw panel
;
redrwincap	.proc
		ldx #<$0428
		ldy #>$0428
		lda man_selectedwin
		beq r1
		ldx #<$0608
		ldy #>$0608
r1		stx m_p4
		sty m_p4+1
		txa
                clc
                adc #231
                sta m_p2
                bcc *+3
                iny
                sty m_p2+1

		ldy #68
		ldx #10
		lda #30+128
		.byte SKIP2
lp2		lda #93+128
		sta (m_p4),y
		tya
		clc
		adc #40
		tay
		bcc *+4
		inc m_p4+1
		dex
		bne lp2
		lda #113+128
		sta (m_p4),y
                dec m_p4+1
                
		ldy #39
lp3		lda winbar,y
                bmi dsc
                bne sc
                lda (m_p4),y
                ora #128
                gmi dsc
sc              eor m_d018
dsc		sta (m_p4),y
		dey
		bpl lp3
                
                asl m_d018
                lsr m_d018

                lda #<winbar2
                sta m_p3
                lda #>winbar2
                sta m_p3+1
		jsr drawtext
                asl m_d018
                sec
                ror m_d018
                #jmps man_printfullfree

winbar		.byte " "+128,"DEVICE",":"+128
		.byte 0,0,0,0,0,0,0,0,0," "+128
		.byte "NAME",":"+128
		.byte 0,0,0,0,0,0,0,0
		.byte 0,0,0,0,0,0,0,0," "+128
winbar2         .byte 13,13,2,28,"BLOCKS"
		.byte 13,13,2,28,"FILES"
                .byte 13,13
		.byte 13,13,2,28,"DRIVE PART",0
		.pend

;---------------------------
; clear screen
;
clrscr		.proc
		ldx #24
		lda #32
		sta $400-24,x
		inx
		bne *-4
		sta $500-24,x
		inx
		bne *-4
		sta $600-24,x
		inx
		bne *-4
		sta $700-24,x
		inx
		bne *-4
		rts
		.pend

;---------------------------
; Print disklabel
;
printdlabel	.proc
		lda #<(man_dirmem1-26)
		sta m_p1
		lda #>(man_dirmem1-26)
		sta m_p1+1

		ldx #<$43f
		ldy #>$43f
		lda man_selectedwin
		beq r1
		ldx #<$61f
		ldy #>$61f
		lda #>(man_dirmem2-26)
		sta m_p1+1
r1		stx m_p2
		sty m_p2+1

		ldy #15
xu		lda (m_p1),y
		tax
		lda cconv,x
		eor #128
		sta (m_p2),y
		dey
		bpl xu
		rts
		.pend

;---------------------------
; Print decimal number
;
numtoasc16	.proc
		stx m_ascii+4
		sta m_ascii+5
		#stz_a m_ascii+1
		#stz_aa m_ascii+2
		#stz_aa m_ascii+3

		ldy #16
		php
		sei
		sed
p2		asl m_ascii+4
		rol m_ascii+5
		ldx #2
p		lda m_ascii+1,x
		adc m_ascii+1,x
		sta m_ascii+1,x
		dex
		bpl p
		dey
		bne p2
		plp
		ldx #133
		gne numtoasc24.in

numtoasc24	.proc
		stx m_ascii+4
		sta m_ascii+5
		sty m_ascii+6
		#stz_a m_ascii
		#stz_aa m_ascii+1
		#stz_aa m_ascii+2
		#stz_aa m_ascii+3

		ldy #24
		php
		sei
		sed
p2		asl m_ascii+4
		rol m_ascii+5
		rol m_ascii+6
		ldx #3
p		lda m_ascii,x
		adc m_ascii,x
		sta m_ascii,x
		dex
		bpl p
		dey
		bne p2
		plp
		ldx #135

		lda (m_p2),y
                and #128
                sta m_ascii+4

		lda m_ascii
		jsr h
in		lda m_ascii+1
		jsr h
		lda m_ascii+2
		jsr h
		lda m_ascii+3

h		pha
		lsr
		lsr
		lsr
		lsr
		jsr aa
		pla
aa		and #15
		bne r2
		dex
		bmi r
r2		ora #$30
		tax
                ora m_ascii+4
		sta (m_p2),y
		iny
r		rts
		.pend
;---------------------------
; Print panel statistics
;
man_printstat	.proc
		ldx #<$4bf
		lda #>$4bf
		ldy man_selectedwin
		beq *+6
		ldx #<$69f
		lda #>$69f

		stx m_p2
		sta m_p2+1
                lda #8
                sta m_p1

		ldx man_block_l,y
		lda man_block_m,y
		pha
		lda man_block_h,y
		tay
		pla
		jsr num

		jsr man_printfullfree

		ldy man_selectedwin
		ldx man_filessel_l,y
		lda man_filessel_h,y
		jsr num2

		ldy man_selectedwin
		ldx man_fulllo,y
		lda man_fullhi,y
		jsr num2
                lda #3
                sta m_p1
		ldy man_selectedwin
		ldx man_drive,y
                jsr num3
		ldy man_selectedwin
		ldx man_partition,y
                lda m_p2
                sec
                sbc #74
                sta m_p2
num3		#lda0
num2		ldy #0
num		jsr numtoasc24
		lda #32
iy		cpy m_p1
		bcs iy2
		sta (m_p2),y
		iny
		bne iy
iy2
		lda m_p2
		clc
		adc #80
		sta m_p2
		bcc *+4
		inc m_p2+1
		rts
		.pend

man_printfullfree .proc
		ldy man_selectedwin
		lda man_fullfree,y
		cmp #"F"
		beq *+3
		clc

		ldy #39
		ldx #4
ig		lda manager.fullbar-1,x
		bcc if
		lda manager.freebar-1,x
if		eor m_d018
		sta (m_p2),y
		iny
		dex
		bne ig
		rts
                .pend
;---------------------------
; Get parameter
;
getparm		.proc
		inc m_p1
		bne *+4
		inc m_p1+1
		lda (m_p1),y
		rts
		.pend

;---------------------------
; Draw 1 line of window
;
windrln		.proc
		sty m_ascii+3
		ldy m_ascii
		sta (m_p1),y
		txa
		sta (m_p2),y
		dey
dy		lda m_ascii+2
		sta (m_p1),y
		txa
		sta (m_p2),y
		dey
		bne dy
		lda m_ascii+3
		sta (m_p1),y
		txa
		sta (m_p2),y
		rts
		.pend

;---------------------------
; Draw a window
;
; .word screen_position		($00xx mean it's in X/Y)
; .byte width-1, height-1
; .word text_in_memory
;
drawwin		.proc
		lda $d011
		bpl *-3
		pla
		sta m_p1
		pla
		sta m_p1+1
                sty m_p4+1

		ldy #0
                jsr getparm
                sta m_p4
                jsr getparm
                bne vd2
                stx m_p4
                .byte SKIP2
vd2             sta m_p4+1
		jsr getparm
		sta m_ascii
		jsr getparm
		sta m_ascii+1
		jsr getparm
		sta m_p3
		jsr getparm
		sta m_p3+1

		lda m_p1+1
		pha
		lda m_p1
		pha

		lda m_p4
		sta m_p1
		sta m_p2
		lda m_p4+1
		sta m_p1+1
		eor #$d8^$04
		sta m_p2+1

		#sta_cfg_open
		#ldatax manager_win_color_exp
		#sta_cfg_16

		.if DECORATION=1
		lda #248
		sta m_ascii+2
		ldy #108
		lda #123
                .else
		lda #64+128
		sta m_ascii+2
		ldy #112+128
		lda #110+128
                .fi
		jsr windrln

lp		lda m_p1
		clc
		adc #40
		sta m_p1
		sta m_p2
		bcc ni
		inc m_p1+1
		inc m_p2+1
ni
		dec m_ascii+1
		beq ki

		lda #32+128
		sta m_ascii+2
                .if DECORATION=1
                ldy #244;245
                lda #234;246
                .else
		lda #93+128
                tay
                .fi
		jsr windrln
		#jmps lp
ki
		.if DECORATION=1
		lda #249
		sta m_ascii+2
		ldy #124
		lda #126
                .else
		lda #64+128
		sta m_ascii+2
		ldy #109+128
		lda #125+128
                .fi
		jsr windrln

drawtext	.proc
fr2		ldy #0
fr		lda (m_p3),y
		bmi ok
		beq vege
		cmp #13
		bne o1
rp		tya
		adc m_p3
		sta m_p3
		bcc *+4
		inc m_p3+1
		lda m_p4
		clc
		adc #40
		sta m_p4
		bcc fr2
		inc m_p4+1
		gcs fr2

o1		cmp #29
		beq oo
                cmp #2
                bne vd
                iny
                lda (m_p3),y
                sta m_p1
                lda m_p3
                sbc m_p1
                sta m_p3
                bcs *+4
                dec m_p3+1
                tya
                sec
                adc m_p1
                tay
                bne fr

vd		cmp #1
		bne okk
		tya
		clc
		adc m_p4
		sta m_p1
		sta m_p2
		lda m_p4+1
		adc #0
		sta m_p1+1
		eor #$d8^$04
		sta m_p2+1

		#phy_a
                .if DECORATION=1
		lda #247;64+128
		sta m_ascii+2
		ldy #244;245
		lda #234;246
                .else
		lda #64+128
		sta m_ascii+2
		ldy #107+128
		lda #115+128
                .fi
		jsr windrln
		#ply_a
		sec
		gcs rp

okk		eor m_d018
ok		sta (m_p4),y
oo		iny
		bne fr
vege		rts
		.pend

;---------------------------
; Restore a window
;
; .word screen_position
; .byte width-1, height-1
;
restorewin	.proc
		lda $d011
		bpl *-3
                lda man_savedwind
                sec
                sbc #6
                sta man_savedwind
                clc
		adc #<(man_savedwin-5)
                sta m_p1
                #lda0
                tay
                adc #>(man_savedwin-5)
                sta m_p1+1
                jsr savewin.wp
		lda #1
		gne savewin.in
;---------------------------
; Save a window
;
; .word screen_position
; .byte width-1, height-1
;
savewin		.proc
		pla
		sta m_p1
		pla
		sta m_p1+1

		ldy #4
                ldx man_savedwind
fwf		lda (m_p1),y
                dex
                sta man_savedwin,x
		dey
                bne fwf

		jsr wp

		lda m_p1+1
		pha
		lda m_p1
		pha

		#lda0
                jsr in
                #ldatax man_savedwind
                clc
                adc #6
                sta man_savedwind
		lda m_p1
		sta man_savedwin,x
		lda m_p1+1
		sta man_savedwin+1,x
                rts
                
in		sta m_ascii+2
		ldx man_savedwind
		lda man_savedwin-6,x
		sta m_p1
		lda man_savedwin-5,x
		sta m_p1+1

lp		ldx m_ascii
		ldy m_ascii+2
		beq fy
		dey
fy2		lda (m_p1),y
		sta (m_p3),y
		inc m_p1
		bne *+4
		inc m_p1+1
		lda (m_p1),y
		sta (m_p4),y
		iny
		dex
		bpl fy2
		gmi rf

fy		lda (m_p3),y
		sta (m_p1),y
		inc m_p1
		bne *+4
		inc m_p1+1
		lda (m_p4),y
		sta (m_p1),y
		iny
		dex
		bpl fy

rf		tya
		clc
		adc m_p1
		sta m_p1
		bcc *+4
		inc m_p1+1

		lda m_p3
		clc
		adc #40
		sta m_p3
		sta m_p4
		bcc *+6
		inc m_p3+1
		inc m_p4+1

		dec m_ascii+1
		bpl lp
		rts

wp		jsr getparm
		sta m_p3
		sta m_p4
		jsr getparm
		sta m_p3+1
		eor #$d8^$04
		sta m_p4+1
		jsr getparm
		sta m_ascii
		jsr getparm
		sta m_ascii+1
                rts
		.pend

;---------------------------
; Handle top menu
;
topmenu		.proc                
ncs             lda 653
		lsr
                bcs bs
                lsr
                bcs ncs
                gcc csv

bs		ldx #6
v               lda $d011
                bmi *-3
		lda $d011
                bpl *-3
                dex
                bne v
                lda $d018
                eor #2
                sta $d018
                lda m_d018
                eor #64
                sta m_d018

		lda man_selectedwin
                pha
                #lda0
                sta man_selectedwin
                sta man_oldsc_h
                sta man_oldsc_h+1
                jsr redrwincap
                jsr scrollbar
		inc man_selectedwin
                jsr redrwincap
                jsr scrollbar
                pla
                sta man_selectedwin

nnf	    	lda 653
                cmp #3
                beq bs
                lsr
                lsr
                bcs nnf
                rts

csv		#stz_a $d015

		lda man_selectedwin
		pha
                sec
		ror man_selectedwin
		jsr winselcolupdate
		pla
		sta man_selectedwin
		#sta_cfg_open

		ldx #39
lp		lda manager_actwincolor_exp
		sta $d800,x
		lda menubar,x
                bmi bx
                eor m_d018
bx		sta $400,x
		dex
		bpl lp
		#sta_cfg_16

		lda man_selectedwin
		beq leftp

rightp		jsr savewin
		.word $447
		.byte 7,10

		jsr drawwin
                .word $447
		.byte 7,10
		.word txtdrives

		lda man_drive+1
		ldx #<$d8c0
		ldy #>$d8c0
		jsr drselm

		pha
		jsr restorewin
		pla
		cmp #29
		beq leftp
		cmp #157
		beq optionsp
		ldx man_selectedwin
		beq kr
                gne lf

key		.byte "8","9","0","1","2","3","4",155,41,129,149,150,151
dr		.byte 8,9,10,11,12,13,14,8,9,11,12,13,14

leftp		jsr savewin
		.word $429
		.byte 7,10

		jsr drawwin
                .word $429
		.byte 7,10
		.word txtdrives

		lda man_drive
		ldx #<$d8a2
		ldy #>$d8a2
		jsr drselm

		pha
		jsr restorewin
		pla
		cmp #157
		beq rightp
		cmp #29
		beq optionsp
		ldx man_selectedwin
                beq lf
kr              pha
                jsr changepanel
                pla
lf		#jmps ss

drselm		pha
		lda #6
		sta m_ascii+2
		lda #5
		sta m_ascii
		pla
		sec
		sbc #8
		bcc e2
		cmp #7
		bcs e2
		.byte SKIP2
e2		lda #0
		sta m_ascii+5
		stx m_p1
		sty m_p1+1

		#sta_cfg_open
		lda manager_selbar_color_exp
		jsr man_paintselbar

		jsr move_sel_bar
		#sta_cfg_16
		rts

optionsp	jsr savewin
		.word $433
		.byte 16,2

		jsr drawwin
                .word $433
		.byte 16,2
		.word txtoptions

		ldx #<$d85c
		ldy #>$d85c
		lda #14
		sta m_ascii
		#stz_a m_ascii+2
		jsr e2

		pha
		jsr restorewin
		pla
		cmp #157
		beq leftp
		cmp #29
		beq rightp
		cmp #13
		beq about
		gne ex

ss		ldy #dr-key
lpp		cmp key-1,y
		bne oo
		lda dr-1,y
		gne n
oo		dey
		bne lpp

		cmp #13
		bne ex

		lda m_ascii+5
                adc #8-1
n               pha
		jsr changepanel
                lda man_selectedwin
                sta man_selectedwin+1
                eor #1
                sta man_selectedwin
                tax
		pla
		sta man_drive,x
		sta ActualDev
                lda #1
                sta man_parlist,x
		jsr winselcolupdate
		jsr topunsel
                jsr man_cdroot
		jsr main_reload2
		#jmps u

ex		jsr winselcolupdate
		jsr topdir

u		lda 653
		and #2
		bne u
		rts			;exit

about		jsr savewin
		.word $59a
		.byte 19,6

		jsr drawwin
                .word $59a
		.byte 19,6
		.word txtabout

		lda 198
		beq *-2
		dec 198

		jsr restorewin
		#jmps ex

txtdrives	.byte 13,29,"DRIVE",":"+128,13,1
		.byte 2,2,"8"+128,13
		.byte 2,2,"9"+128,13
		.byte 2,1,"1"+128,"0"+128,13
		.byte 2,1,"1"+128,"1"+128,13
		.byte 2,1,"1"+128,"2"+128,13
		.byte 2,1,"1"+128,"3"+128,13
		.byte 2,1,"1"+128,"4"+128,0

txtoptions	.byte 13,29,29,"ABOUT"," "+128,"MANAGER",0

txtabout	.byte 13,29,29,"IDE"," "+128,"FILE"," "+128,"MANAGER",13,1
		.byte 29,29,"VERSION",":"+128," "+128,"0"+128,"."+128,"0"+128,"0"+128,13
		.byte 29,29,"DATE",":"+128," "+128,"2"+128,"0"+128,"0"+128,"4"+128,"/"+128,"0"+128,"6"+128,"/"+128,"2"+128,"6"+128,13
		.byte 29,29,"HTTP",":"+128,"/"+128,"/"+128,"IDE","6"+128,"4"+128,"."+128,"ORG",0

menubar		.byte " "+128," "+128," "+128," "+128,"UP"," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128
		.byte " "+128,"MISC"," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128
		.byte "DOWN"," "+128," "+128," "+128
		.pend

topunsel	.proc
		clv
                gvc topdir.in
		
topdir		.proc
		
                jsr rel_path_m_p1
                
                lda m_p1
                clc
                adc #3
                sta m_p1
                bcc *+4
                inc m_p1+1

		#sev g

in              ldy #0
lp3		#sta_cfg_open
		lda manager_inactwincolor_exp
                #sta_cfg_16
		sta $d800,y
                bvc kr
                .if SUPERCPU=1
		lda (m_p1),y
                tax
                .else
                lax (m_p1),y
                .fi
                bne vm
                clv
kr              ldx #32
vm		lda cconv,x
		eor #$80
		sta $400,y
                iny
                cpy #40
		bne lp3
g		rts
		.pend
;---------------------------
; Color selection bar
;
man_paintselbar	.proc
		pha
		lda m_p1
		sta m_p2
		lda m_p1+1
		sta m_p2+1
		ldy m_ascii+5
c2		clc
c		dey
		bmi i
		lda m_p2
		adc #40
		sta m_p2
		bcc c
		inc m_p2+1
		gcs c2

i		pla
		ldy m_ascii
ll		sta (m_p2),y
		dey
		bpl ll
		rts
		.pend

;---------------------------
; Move menu selector
;
move_sel_bar	.proc
lp		lda 198
		beq *-2
		lda 631
		dec 198

		cmp #17
		bne n1
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx m_ascii+5
		cpx m_ascii+2
		inx
		bcc *+4
		ldx #0
		stx m_ascii+5
l		lda manager_selbar_color_exp
		jsr man_paintselbar
		#jmps lp

n1		cmp #145
		bne n2
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx m_ascii+5
		dex
		bpl *+4
		ldx m_ascii+2
ll		stx m_ascii+5
		#jmps l

n2		cmp #137
		beq *+10
		cmp #133
		beq *+6
		cmp #19
		bne n3
		lda m_ascii+5
		beq lp
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx #0
		geq ll
n3
		cmp #140
		beq *+10
		cmp #136
		beq *+6
		cmp #147
		bne n4
		lda m_ascii+2
		cmp m_ascii+5
		beq lp
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx m_ascii+2
		#jmps ll

n4
		rts
		.pend

scrollbar	.proc
		lda #<$494
		ldy #>$494
		ldx man_selectedwin
		beq *+6
		lda #<$674
		ldy #>$674
		sta m_p2
		sty m_p2+1

		lda man_files_l,x
		sec
		sbc #1
		sta m_p3
		lda man_files_h,x
		sbc #0
		sta m_p3+1
		ora m_p3
		bcc e
		beq e
		lda man_el_l,x
		clc
		adc man_bar,x
		sta m_p1
		lda man_el_h,x
		adc #0
		asl m_p1
		rol
		asl m_p1
		rol
		asl m_p1
		rol
		sta m_p1+1

cg2		sec
cg		lda m_p1
		sbc m_p3
		sta m_p1
		lda m_p1+1
		sbc m_p3+1
		sta m_p1+1
		bcc e

		lda m_p2
		adc #40-1
		sta m_p2
		bcc cg2
		inc m_p2+1
		gcs cg

e		lda man_oldsc_l,x
		ldy man_oldsc_h,x
		beq nn
		cmp m_p2
		bne n
		cpy m_p2+1
		beq ni
n		sta m_p3
		sty m_p3+1
		ldy #0
		lda #221
		sta (m_p3),y
nn		lda #64			;186
		sta (m_p2),y
		lda m_p2
		sta man_oldsc_l,x
		lda m_p2+1
		sta man_oldsc_h,x
ni		rts
		.pend

;---------------------------
; main copy
;
main_copy	.proc
		lda man_files_l,x
		ora man_files_h,x
		beq err
                lda man_parlist,x
                lsr
                bne err
		
		lda man_filessel_l,x
		ora man_filessel_h,x
		beq copycurrent

                jsr savewin
		.word $543
		.byte 33,8

		#stz_a man_multi
		#stz_aa man_multi+1

lp		ldy man_selectedwin
		#ldatax man_multi
		cmp man_files_l,y
		lda man_multi+1
		sbc man_files_h,y
		bcs ss2
		lda man_multi+1
                lsr
		txa
		jsr calc_filepos
                jsr man_dir
                bmi k
		jsr man_sel
		bpl k
                jsr processfilename
		jsr man_toggle_sel
                jsr copyf
                jsr changepanel

k		inc man_multi
		bne lp
		inc man_multi+1
		gne lp

ss2		jsr restorewin
		jsr printdir
		jsr changepanel
		#jmps ss


copycurrent    	jsr calc_filepos_cursor
		lda m_p1+1
                cmp #>man_dirmem1
                bcc err
		jsr processfilename

		jsr savewin
		.word $571
		.byte 21,6

		jsr drawwin
                .word $571
		.byte 21,6
		.word txtcopy

		ldy #19
ndu		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
		sta $5c2,y
                #sta_cfg_open
                lda manager_input_color_exp
                #sta_cfg_16
                sta $d9c2,y
		dey
		bpl ndu

		ldx #<$63a
		ldy #>$63a
		lda #20
		jsr input
                pha
		jsr restorewin
		pla
                cmp #3
                beq err
                
                jsr savewin
		.word $543
		.byte 33,8

                jsr copyf
                jsr restorewin
                
ss		jsr modifieddir
                jsr changepanel

err		rts		;exit

copyf           jsr drawwin
                .word $543
		.byte 33,8
		.word txtcopy2

                ldx #31
cx		lda man_dirmem2,x
                sta man_temp,x
                dex
                bpl cx

		ldy #20
ndu2    	ldx $200,y
		bne *+4
		ldx #32
		lda cconv,x
                eor #128
		sta $573,y
		ldx man_input-1,y
		bne *+4
		ldx #32
		lda cconv,x
                eor #128
		sta $5c3,y
		dey
		bne ndu2
                sty m_p3
                sty m_p3+1
                sty m_p4
                sty man_copybar+3
		sty m_p5
		sty m_p5+1
                sty m_p4+1
                lda #<$614
                sta m_p2
                lda #>$614
                sta m_p2+1

		ldx ActualDev
                lda #1
                ldy #0
                jsr $ffba
		ldx #<$201
                ldy #>$201
                lda ActualFNLength
                jsr $ffbd

                jsr newopen_t

		ldx #0
vsd		lda man_input,x
                beq kv
                sta $201,x
                inx
                cpx #20
                bne vsd
kv		stx $200

                jsr changepanel

                ldx $ba
                lda #2
                ldy #1
                jsr $ffba

		lda $200
                ldx #<$201
                ldy #>$201
                jsr $ffbd

                jsr newopen_t

		ldx #1
                jsr newchkin_t
                ldx #2
                jsr newchkout_t

		ldx man_selectedwin
                ldy dirm,x
                iny
                sty m_p1+1
                #lda0
                sta m_p1

re              ldx #0
                ldy #64
                lda #m_p1
                jsr newread_t
                bcc mv
                jsr inout
                lda m_p1+1
                sta m_ascii+2
                ldx #8
                ldy #0
nvx             jsr newchrin_t
                sta (m_p1),y
                lda Status
                bne jo
                iny
                bne nvx
                inc m_p1+1
                dex
                bne nvx
kb
                .if SUPERCPU=1
                tyx
                .else
                tya
                tax
                .fi
                lda m_p1+1
                sec
                sbc m_ascii+2
                tay
                lda m_ascii+2
                sta m_p1+1
                gne mv

jo              cmp #$42
		beq kb
                iny
                bne kb
                inc m_p1+1
                gne kb

mv		lda Status
                pha

                jsr man_showbar

		txa
                eor #$ff
                sta m_ascii
                tya
                eor #$ff
                sta m_ascii+1
                
                lda #m_p1
                jsr newwrite_t
                bcc mv2
                jsr inout
                lda m_p1+1
                sta m_ascii+2
                ldy #0
                jsr copy_upper

                .if SUPERCPU=1
                tyx
                .else
                tya
                tax
                .fi
                lda m_p1+1
                sec
                sbc m_ascii+2
                tay
                lda m_ascii+2
                sta m_p1+1

mv2             lda Status
                bne baj
                tya
                clc
                adc m_p3
                sta m_p3
                bne vx
                inc m_p3+1
                bne vx
                inc m_p4
vx

		jsr man_showbar

                ldx m_p3
		lda m_p3+1
                ldy m_p4
		jsr numtoasc24

                pla
                beq re
                .byte SKIP1
baj		pla

		jsr newclrchn_t
                lda #1
                jsr newclose_t
                
                jsr read_errchannel
                jsr showerror
                
                lda #2
                jsr newclose_t

                jsr read_errchannel
                jsr showerror
                
                ldx #31
cx2		lda man_temp,x
                sta man_dirmem2,x
                dex
                bpl cx2
                rts


                
inout		ldx #1
                jsr newchkin_t
                ldx #2
                jmp newchkout_t

txtcopy		.byte 2,6,decor_bal,"COPY",decor_jobb,13
		.byte 29,"FROM",":"+128,13,13,13
		.byte 29,"TO",":"+128,0

txtcopy2       	.byte 2,11,decor_bal,"COPYING",decor_jobb,13
		.byte 29,"FROM",":"+128,13,13
		.byte 29,"TO",":"+128,13,13
		.byte 29,"BLOCKS",":"+128,0
		.pend

;---------------------------
; process filename for copy/delete
;
processfilename	.proc
		jsr man_copyfname

		ldy #5
ld		lda (ActualFilename),y
		cmp illtype,y
		bne yh
		dey
		bpl ld
                iny
                sty ActualFNLength      ;illegal name
		rts

yh		ldy #0
		lda (m_p1),y
                asl
                sta man_copybar
                iny
                lda (m_p1),y
                rol
                sta man_copybar+1
                lda #0
                rol
                sta man_copybar+2
                dey
nd		lda (ActualFilename),y
		cpy ActualFNLength
		bcc vf
		#lda0
                sta (ActualFilename),y
vf		sta man_input,y
		iny
		cpy #20
		bne nd
                rts

illtype		.text "..,DIR"
		.pend
;---------------------------
; main mkdir
;
main_mkdir	.proc
                lda man_parlist,x
                lsr
                bne xjx

		jsr savewin
		.word $59b
		.byte 17,4

		jsr drawwin
                .word $59b
		.byte 17,4
		.word txtmkdir

		ldx #<$614
		ldy #>$614
		lda #16
		jsr clrinput
		cmp #3			;stop?
		beq xji

		ldx #16
ul		lda man_input,x
		sta man_input+3,x
		lda mdtxt,x
		sta man_input,x
		dex
		bpl ul

		jsr do_errchannel
                jsr showerror

		clc
xji	        php
		jsr restorewin
                plp
                bcs xjx
		#jmps modifieddir

xjx		rts

mdtxt		.text "MD:"
txtmkdir	.byte 13,29,29,"MAKE"," "+128,"DIRECTORY",13,1,0
		.pend
;---------------------------
; main delete
;
main_delete	.proc
		lda man_files_l,x
		ora man_files_h,x
		beq err
                lda man_parlist,x
                lsr
                bne err

		lda man_filessel_l,x
		ora man_filessel_h,x
		bne ncurrent

	  	jsr calc_filepos_cursor
		jsr man_toggle_sel
ncurrent
                lda #"N"
                sta 631

                jsr savewin
		.word $599
		.byte 21,4

		jsr drawwin
                .word $599
		.byte 21,4
		.word txtdelete2

		#stz_a man_multi
		#stz_aa man_multi+1

lp		ldy man_selectedwin
		#ldatax man_multi
		cmp man_files_l,y
		lda man_multi+1
		sbc man_files_h,y
		bcs ss2
		lda man_multi+1
                lsr
		txa
		jsr calc_filepos
                jsr man_dir
                bmi k
		jsr man_sel
		bpl k
                jsr processfilename
		jsr man_toggle_sel

                lda 631
                ldx #0
                stx 198
                cmp #"A"
                beq all

                jsr savewin
		.word $571
		.byte 21,6

		jsr drawwin
                .word $571
		.byte 21,6
		.word txtdelete

		ldy #19
ndu		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
                eor #$80
		sta $5ea,y
		dey
		bpl ndu

		ldx 198
                beq *-2

		jsr restorewin
                
                lda 631
                dec 198
                cmp #"Y"
                beq all
                cmp #"A"
                beq all
                cmp #3
                bne no
                
ss2		jsr restorewin
		#jmps modifieddir
err		rts		;exit

all
                ldy #20
ndu2    	ldx man_input-1,y
		bne *+4
		ldx #32
		lda cconv,x
                eor #128
		sta $611,y
                txa
                cmp #","
                bne *+4
                lda #"="
                sta man_input+1,y
		dey
		bne ndu2

		lda #"S"
                sta man_input
                lda #":"
                sta man_input+1

		ldx #<man_input
                ldy #>man_input
                lda ActualFNLength
                clc
                adc #2
                jsr $ffbd
                jsr read_errchannel.inn
                jsr showerror
no
k		inc man_multi
		bne lp
		inc man_multi+1
		gne lp

txtdelete      	.byte 13,2,6,"DELETE",13,1,13,13
		.byte 2,4,"YES","/"+128,"NO","/"+128,"ALL",0

txtdelete2     	.byte 13,2,5,"DELETING",13,1,0
		.pend
;---------------------------
man_showbar	.proc
		txa
                pha
                clc
                adc m_p5
                sta m_p5
                tya
                pha
                adc m_p5+1
                sta m_p5+1
                bcc *+4
                inc m_p4+1

		ldx man_copybar+3
xc		stx man_copybar+3
                ldy m_p5
                cpy man_copybar
		lda m_p5+1
		sbc man_copybar+1
                lda m_p4+1
                sbc man_copybar+2
                bcc we
                sta m_p4+1
		tya
                sbc man_copybar
                sta m_p5
                lda m_p5+1
		sbc man_copybar+1
                sta m_p5+1
                inx
                bne xc
                dex
we
		txa
                and #7
                tay
                txa
                lsr
                lsr
                lsr
                tax
                lda bar,y
jw              sta $65c,x
                lda #32
                dex
                bpl jw
                #ply_a
                #plx_a
jooo            rts
bar		.byte 229,244,245,225,118,106,103,32
		.pend
;---------------------------
; reload other panel too if change happend in same dir
;
modifieddir     .proc
		jsr main_reload
                jsr same_dir
                bne man_showbar.jooo
                jsr changepanel
                jsr main_reload2.in
                jmp changepanel
		.pend
;---------------------------
; main command
;
main_command	.proc
                lda man_floppy,x
                beq x

		jsr savewin
		.word $595
		.byte 29,5

		jsr drawwin
                .word $595
		.byte 29,5
		.word txtcmd

		ldx #<$60e
		ldy #>$60e
		lda #28
		jsr clrinput
		cmp #3			;stop?
		php
		beq xji
                
tk		jsr do_errchannel

		clc
xji		php

		jsr restorewin

                plp
                bcs *+5
                jsr showerror

		plp
		bne modifieddir
x		rts

txtcmd		.byte 13,2,7,"DISK"," "+128,"COMMAND",13,1,0
		.pend
;---------------------------
; Screen input
;
clrinput	.proc
		stx m_p1
                pha
                tax
                #lda0
ld              sta man_input,x
                dex
                bpl ld
                pla
                ldx m_p1

input		.proc
maxlen		= m_p2
cpos		= m_p2+1
first		= m_p3

		stx m_p1
                stx m_p4
		sty m_p1+1
		sta maxlen
                tya
                eor #$d8^$04
                sta m_p4+1
		#stz_a cpos
		lda #192
		sta first

lp		asl first
		ldy #0
r		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
		sta (m_p1),y
                #sta_cfg_open
                lda manager_input_color_exp
                #sta_cfg_16
                sta (m_p4),y
		iny
		cpy maxlen
		bne r

		ldy cpos
		ldx #0

lp1		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		dex
		bpl l
		ldx #16
		lda (m_p1),y
		eor #128
		sta (m_p1),y
l		lda 198
		beq lp1
		lda 631
		dec 198

;       	cmp #","
;       	beq lp
;       	cmp #":"
;       	beq lp
		cmp #"="
		beq lp

		cmp #20			;del
		bne n1
		cpy #0
		beq lp
		iny
		cpy maxlen
		bne y
		lda man_input-1,y
		beq y
ld		#lda0
		sta man_input-1,y
		geq lp
y		dey
lp2		lda man_input,y
		sta man_input-1,y
		iny
		cpy maxlen
		bcc lp2
		dec cpos
		gcs ld

n1
		cmp #157		;left
		bne n2
		cpy #0
		beq lp
		dec cpos
		#jmps lp
n2
		cmp #29			;right
		bne n3
		iny
		cpy maxlen
		beq lp
		lda man_input-1,y
		beq lp
		cpy maxlen
		beq lp
		sty cpos
		gne lp

n3
		cmp #19
		bne n4
		#stz_a cpos
		geq lp
n4
		cmp #147
		bne n5
		#lda0
		ldy maxlen
lh		sta man_input,y
		dey
		bpl lh
		sta cpos
		gmi lp
n5
		cmp #148
		bne n6
		ldy maxlen
		lda man_input-1,y
		bne lp
t		dey
		cpy cpos
		beq py
		lda man_input-1,y
		sta man_input,y
		#jmps t
py		lda #32
		sta man_input,y
		gne lp

n6
		cmp #3
		beq exit
		cmp #13
		beq exit

		ldx first
		beq ig
		pha
		ldx maxlen
		#lda0
li		sta man_input,x
		dex
		bpl li
		pla

ig		sta man_input,y
		ldx cpos
		inx
		cpx maxlen
		bcs lp
		stx cpos
		gcc lp
exit		rts
		.pend
;---------------------------
; Path of current window into ActualFilename
;
rel_path_filename .proc
                lda man_selectedwin
                clc
                adc #>man_relpath
                sta ActualFilename+1
                lda #<man_relpath
                sta ActualFilename
                rts
                .pend
;---------------------------
; Path of current window into m_p1, Y at end of name
;
rel_path_m_p1  	.proc
                lda man_selectedwin
                clc
                adc #>man_relpath
                sta m_p1+1
                lda #<man_relpath
                sta m_p1
                ldy #0
nvfs            lda (m_p1),y
                beq kmv
                iny
                bne nvfs
kmv		rts
		.pend
;---------------------------
; Manager data swap
;
manager_data_swap .proc
		#sta_cfg_open
		lda #<man_data
                sta m_p3
		lda #>man_data
                sta m_p3+1
		lda #<manager_data_exp
                sta m_p1
		lda #>manager_data_exp
                sta m_p1+1
                .if SUPERCPU=1
                ldy #1
                sty m_p1+2
                dey
lp		lda (m_p3),y
		tax
                .else
                ldy #0
lp              lax (m_p3),y
                .fi
                #lda_zp_y m_p1
                sta (m_p3),y
                txa
                #sta_zp_y m_p1
                dey
                bne lp
                inc m_p1+1
                inc m_p3+1
                lda m_p3+1
                cmp #>(man_data+$300)
                bne lp
                #sta_cfg_16
                rts
		.pend

;---------------------------
; Check/set manager sign
;
man_set_sign	.proc
		clc
		.byte SKIP1
man_check_sign	.proc
		sec
		ldx #38
ldl             #sta_cfg_open
                lda ident_label_exp-1,x
                #sta_cfg_16
                bcc vdv
                cmp man_ident_label-1,x
                bne vs
vdv             sta man_ident_label-1,x
                dex
                bne ldl
vs              rts
                .pend
;---------------------------
; Same directory?
;
same_dir	.proc
                lda man_drive
                eor man_drive+1
                bne no
                lda man_partition
                eor man_partition+1
                bne no
                ldx #0
nvs             lda man_relpath,x
                cmp man_relpath+$100,x
                bne no
                tay
                beq no
                inx
                bne nvs
no		rts
		.pend
;
manager_colors	.byte 6 		;manager_bgcolor_exp
		.byte 6			;manager_brcolor_exp
                .byte 12		;manager_inactwincolor_exp
		.byte 7			;manager_actwincolor_exp
		.byte 15		;manager_dircolor_exp
		.byte 14		;manager_filecolor_exp
		.byte 7			;manager_seldircolor_exp
		.byte 7			;manager_selfilecolor_exp
		.byte 0			;manager_bar_color_exp
		.byte 12		;manager_misc_color_exp
		.byte 7			;manager_win_color_exp
		.byte 1			;manager_selbar_color_exp
                .byte 3			;manager_input_color_exp
;---------------------------
; Manager data
;
		.logical $0900
man_data	= *
man_selectedwin	*=*+2			;which panel is active? (0/1)
man_drive	*=*+2			;drive number
man_valid	*=*+2			;panel valid
man_files_l	*=*+2			;number of files
man_files_h	*=*+2			;number of files
man_bar		*=*+2			;bar position
man_el_l	*=*+2			;scroll position
man_el_h	*=*+2			;scroll position
man_fulllo	*=*+2			;blocks used
man_fullhi	*=*+2			;blocks used
man_fullfree	*=*+2			;full/free
man_partition	*=*+2			;partition
man_parlist	*=*+2			;partition list
man_block_l	*=*+2			;blocks selected
man_block_m	*=*+2			;blocks selected
man_block_h	*=*+2			;blocks selected
man_ident_label *=*+38			;identification
man_filessel_l	*=*+2			;files selected
man_filessel_h	*=*+2                   ;files selected
man_floppy	*=*+2                   ;drive is floppy
man_oldsc_l	*=*+2			;old scrollbar
man_oldsc_h	*=*+2                   ;old scrollbar
man_oldvic	*=*+47			;vic state
man_old650	*=*+1			;keyboard repeat state
man_old657	*=*+1			;keyboard repeat state
man_savedwind	*=*+1
man_savedwin	*=*+(6*3)+2    		;to remember saved window
man_input				;input space
man_errchannel	*=*+128			;error message
man_pontpont	*=*+32			;for ".."
man_relpath	*=*+512			;paths
man_copybar	*=*+4
man_multi	*=*+2

		.if *>$1000
		.error "man data overflow!"
		.fi
		.here

		.logical $1000
man_sort1_l	*=*+512
man_sort1_h	*=*+512
man_sort2_l	*=*+512
man_sort2_h	*=*+512
man_temp	= *
man_l_l		*=*+64
man_l_h		*=*+64
man_r_l		*=*+64
man_r_h		*=*+64
man_i_l		*=*+64
man_i_h		*=*+64
man_j_l		*=*+64
man_j_h		*=*+64
		.if *>$1e00
		.error "man data overflow!"
		.fi
		.here
